#!/bin/bash
if : ; then
# File:            timestamp.sh
# Name:            Kevin Crotty
# Date:            26 Mar 2019
# Desc:            Demonstrate different timestamps
# Usage:          ./timestamp.sh (as root)

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

# Example demonstraion of color usage
# echo -e "${BGreen} \# \n "
# echo -e "\n${BRed} ${NC}"
fi

# '-c' prevents the creation of a file; no arguments changes a, m, and c times
echo -e "\n${BRed}touch -c time.txt${NC}"
touch -c time.txt
echo -e "\n${BRed}stat time.txt | grep 2019${NC}"
stat time.txt | grep "2019"
echo -e "\n${BRed}touch time.txt${NC}"
touch time.txt
echo -e "\n${BRed}stat time.txt${NC}"
stat time.txt
echo -e "\n${BRed}stat time.txt | grep 2019${NC}"
stat time.txt | grep "2019"


# '-a'  changes only the access time
echo -e "\n${BRed}touch -a -r self.sh time.txt${NC}"
touch -a -r umask.sh time.txt
echo -e "\n${BRed}stat self.sh | grep 2019${NC}"
stat umask.sh | grep "2019"
echo -e "\n${BRed}stat time.txt | grep 2019${NC}"
stat time.txt | grep "2019"

# '-t'  allows you to specify a specific date
echo -e "\n${BRed}touch -c -t 201911150830.28 time.txt${NC}"
touch -c -t 201911150830.28 time.txt
echo -e "\n${BRed}stat time.txt | grep 2019${NC}"
stat time.txt | grep "2019"

rm time.txt
