#!/bin/bash
if : ; then
# File:         regex.sh
# Name:         Kevin Crotty
# Date:         31 Mar 2019
# Desc:         Regular Expressions in Bash
# Usage:        ./regex.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi
reset

colorComment "# Set a variable to a Extended REGEX Pattern"
colorCommand "regex='${BRed}^${BPurple}([A-Z][a-zA-Z]+)${BRed} [a-zA-Z]+ ${BBlue}([a-zA-Z]+)${BRed} .*\.\$${BRed}'${NC}"

colorComment "# Create testable lines in a file"
colorCommand "echo \"this is a sentence\" > test.txt"
colorCommand "echo \"This is a sentence\" >> test.txt"
colorCommand "echo \"This is a sentence.\" >> test.txt"

colorComment "# Use a while loop to test each line of the file"
colorCommand "while read line"
colorCommand "do"
colorCommand "    echo \$line"
colorCommand "    if [[ \$line =~ \$regex ]]"
colorCommand "    then"
colorCommand "        echo \"BASH_REMATCH[${BCyan}0${BRed}] = \${BASH_REMATCH[${BCyan}0${BRed}]}\"${NC}"
colorCommand "        echo \"BASH_REMATCH[${BPurple}1${BRed}] = \${BASH_REMATCH[${BPurple}1${BRed}]}\"${NC}"
colorCommand "        echo \"BASH_REMATCH[${BBlue}2${BRed}] = \${BASH_REMATCH[${BBlue}2${BRed}]}\"${NC}"
colorCommand "    else"
colorCommand "        echo \"No Match\""
colorCommand "    fi"
colorCommand "    echo"
colorCommand "done < test.txt\n"

echo -e "this is a sentence"
echo -e "No Match"

echo -e "\nThis is a sentence"
echo -e "No Match"

echo -e "\nThis is a sentence."
echo -e "BASH_REMATCH[0] = ${BCyan}This is a sentence.${NC}"
echo -e "BASH_REMATCH[1] = ${BPurple}This${NC}"
echo -e "BASH_REMATCH[2] = ${BBlue}a${NC}\n\n"
