# --- COLOR VARIABLES AND FUNCTIONS --- #
    export NC='\e[0m'               # Text Reset
    export BBlack='\e[1;30m'        # Black
    export BRed='\e[1;31m'          # Red
    export BGreen='\e[1;32m'        # Green
    export BYellow='\e[1;33m'       # Yellow
    export BBlue='\e[1;34m'         # Blue
    export BPurple='\e[1;35m'       # Purple
    export BCyan='\e[1;36m'         # Cyan
    export BWhite='\e[1;37m'        # White
    export NC='\e[0m'               # Text Reset
    export Black='\e[0;30m'         # Black
    export Red='\e[0;31m'           # Red
    export Green='\e[0;32m'         # Green
    export Yellow='\e[0;33m'        # Yellow
    export Blue='\e[0;34m'          # Blue
    export Purple='\e[0;35m'        # Purple
    export Cyan='\e[0;36m'          # Cyan
    export White='\e[0;37m'         # White

    function comm { echo -e "${BGreen}${1}${NC}"
    }
    function cli { echo -e "${Red}# ${1}${NC}"
    }
    function label { echo -e "${BBlue}${1}${NC}\n"
    }
    function output { echo -e "${NC}${1}\n"
    }

reset

    label "--- 'find' Syntax Standards ---"
    comm '=========================================================================================='
    comm '**OPTIONS (ie. -maxdepth 1) before TESTS (ie. -name or -type f) before ACTIONS (ie. -exec)'
    comm '**For Example:\n'
    comm "find / -exec ls -l {} \; -name pass* -type f   ${BPurple}<--  Wrong${NC}"
    comm "find / -type f  -name pass* -exec ls -l {} \;   ${BPurple}<--  Correct${NC}"
    comm '==========================================================================================\n\n'


    label "--- 'find' Examples ---"
    comm '# Find all files in "/etc/" that start with the pattern "pass"'
    cli "find /etc -type f -name pass* 2>/dev/null | head"

    output \
'/etc/cron.daily/passwd
/etc/pam.d/passwd
/etc/passwd
/etc/passwd-'

    comm '#  Find all files in "/etc/" that start with the pattern "pass"'
    comm '#+ and only search one directory level deep.'
    cli "find /etc -maxdepth 1 -type f -name pass* 2>/dev/null | head"

    output \
'/etc/passwd
/etc/passwd-'

    comm '# Find all files that have been modified in the last 24 hours'
    cli "find /repo/ -mtime 0 2>/dev/null | head"

    output \
'/repo/
/repo/public.eb
/repo/public.eb/.gitlab-ci.yml
/repo/public.eb/.git
/repo/public.eb/.git/hooks/post-commit
/repo/public.eb/.git/hooks/pre-push'

    comm '# Find all scripts in the current directory, owned by root'
    cli "find \$PWD -user root -name  \"*.sh\"  2>/dev/null | head"

    output \
'/repo/linux-v1-class/scripts/4_RegexBasics/find.sh
/repo/linux-v1-class/scripts/4_RegexBasics/grep.sh'

    comm '# Find all files on the system that have the SUID bit set and owned by "root"'
    cli "find / -user root -perm /4000 -print 2>/dev/null | head"

    output \
'/snap/core/7270/bin/mount
/snap/core/7270/bin/ping
/snap/core/7270/bin/ping6
/snap/core/7270/bin/su
/snap/core/7270/bin/umount
/snap/core/7270/usr/bin/chfn\n\n'
