#!/bin/bash
if : ; then
# File:         grep.sh
# Name:         Kevin Crotty
# Date:         25 Mar 2019
# Desc:         Show a bunch of grep examples
# Usage:        source grep.sh NOTE: Make sure {1..3}grep.txt are in the same directory

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export Cyan='\e[0;36m'         # Cyan
export BWhite='\e[1;37m'        # White

# Example demonstraion of color usage
# echo -e "${BGreen} \# \n "
# echo -e "\n${BRed} ${NC}"
fi

reset

echo -e "${NC}"
echo -e "${BRed}grep root /etc/passwd${NC}"
echo -e "${BPurple}root${NC}:x:0:0:${BPurple}root${NC}:/${BPurple}root${NC}:/bin/bash${NC}"
echo -e "${NC}"
echo -e "${BRed}grep -o root /etc/passwd${NC}"
echo -e "${BPurple}root${NC}"
echo -e "${BPurple}root${NC}"
echo -e "${BPurple}root${NC}"
echo -e "${NC}"
echo -e "${BRed}grep -v root /etc/passwd | head${NC}"
echo -e "daemon:x:1:1:daemon:/usr/sbin:/usr/sbin/nologin${NC}"
echo -e "bin:x:2:2:bin:/bin:/usr/sbin/nologin${NC}"
echo -e "sys:x:3:3:sys:/dev:/usr/sbin/nologin${NC}"
echo -e "sync:x:4:65534:sync:/bin:/bin/sync${NC}"
echo -e "games:x:5:60:games:/usr/games:/usr/sbin/nologin${NC}"
echo -e "man:x:6:12:man:/var/cache/man:/usr/sbin/nologin${NC}"
echo -e "lp:x:7:7:lp:/var/spool/lpd:/usr/sbin/nologin${NC}"
echo -e "mail:x:8:8:mail:/var/mail:/usr/sbin/nologin${NC}"
echo -e "news:x:9:9:news:/var/spool/news:/usr/sbin/nologin${NC}"
echo -e "uucp:x:10:10:uucp:/var/spool/uucp:/usr/sbin/nologin${NC}"
echo -e "${NC}"
echo -e "${BRed}grep -C 2 gnats /etc/passwd${NC}"
echo -e "list:x:38:38:Mailing List Manager:/var/list:/usr/sbin/nologin${NC}"
echo -e "irc:x:39:39:ircd:/var/run/ircd:/usr/sbin/nologin${NC}"
echo -e "${BPurple}gnats${NC}:x:41:41:Gnats Bug-Reporting System (admin):/var/lib/gnats:/usr/sbin/nologin${NC}"
echo -e "nobody:x:65534:65534:nobody:/nonexistent:/usr/sbin/nologin${NC}"
echo -e "systemd-network:x:100:102:systemd Network Management,,,:/run/systemd/netif:/usr/sbin/nologin${NC}"
echo -e "${NC}"
echo -e "############################${NC}"
echo -e "${NC}"
echo -e "${BRed}hello='hello world'${NC}"
echo -e "${NC}"
echo -e "${BRed}grep \$hello *grep.txt${NC}"
echo -e "grep: world: No such file or directory${NC}"
echo -e "${Cyan}1grep.txt:${BPurple}hello${NC} world${NC}"
echo -e "${Cyan}2grep.txt:${BPurple}hello${NC} world${NC}"
echo -e "${Cyan}3grep.txt:not ${BPurple}hello${NC} world${NC}"
echo -e "${NC}"
echo -e "${BRed}grep \"\$hello\" *grep.txt${NC}"
echo -e "${Cyan}1grep.txt:${BPurple}hello world${NC}"
echo -e "${Cyan}2grep.txt:${BPurple}hello world${NC}"
echo -e "${Cyan}3grep.txt:not ${BPurple}hello world${NC}"
echo -e "${NC}"
echo -e "${BRed}grep '\$hello' *grep.txt${NC}"
echo -e "${NC}"
echo -e "############################${NC}"
echo -e "${NC}"
echo -e "${BRed}grep  \"\d\d\d\d\d\" /etc/passwd    ${BGreen}<-- Regular${NC}"
echo -e "${NC}"
echo -e "${BRed}egrep \"\d\d\d\d\d\" /etc/passwd    ${BGreen}<-- Extended${NC}"
echo -e "${NC}"
echo -e "${BRed}grep -P \"\d\d\d\d\d\" /etc/passwd    ${BGreen}<-- Perl(PCRE)${NC}"
echo -e "sync:x:4:${BPurple}65534${NC}:sync:/bin:/bin/sync${NC}"
echo -e "nobody:x:${BPurple}65534${NC}:${BPurple}65534${NC}:nobody:/nonexistent:/usr/sbin/nologin${NC}"
echo -e "_apt:x:104:${BPurple}65534${NC}::/nonexistent:/usr/sbin/nologin${NC}"
echo -e "dnsmasq:x:108:${BPurple}65534${NC}:dnsmasq,,,:/var/lib/misc:/usr/sbin/nologin${NC}"
echo -e "kernoops:x:113:${BPurple}65534${NC}:Kernel Oops Tracking Daemon,,,:/:/usr/sbin/nologin${NC}"
echo -e "gnome-initial-setup:x:120:${BPurple}65534${NC}::/run/gnome-initial-setup/:/bin/false${NC}"
echo -e "sshd:x:123:${BPurple}65534${NC}::/run/sshd:/usr/sbin/nologin${NC}"
echo -e "${NC}"
echo -e "${NC}"
echo -e "${BRed}egrep \"[0-9][0-9][0-9][0-9][0-9]\" /etc/passwd${NC}"
echo -e "sync:x:4:${BPurple}65534${NC}:sync:/bin:/bin/sync${NC}"
echo -e "nobody:x:${BPurple}65534${NC}:${BPurple}65534${NC}:nobody:/nonexistent:/usr/sbin/nologin${NC}"
echo -e "_apt:x:104:${BPurple}65534${NC}::/nonexistent:/usr/sbin/nologin${NC}"
echo -e "dnsmasq:x:108:${BPurple}65534${NC}:dnsmasq,,,:/var/lib/misc:/usr/sbin/nologin${NC}"
echo -e "kernoops:x:113:${BPurple}65534${NC}:Kernel Oops Tracking Daemon,,,:/:/usr/sbin/nologin${NC}"
echo -e "gnome-initial-setup:x:120:${BPurple}65534${NC}::/run/gnome-initial-setup/:/bin/false${NC}"
echo -e "sshd:x:123:${BPurple}65534${NC}::/run/sshd:/usr/sbin/nologin${NC}"
echo
echo
