#!/bin/bash
if : ; then
# File:         sed.sh
# Name:         Kevin Crotty
# Date:         1 Apr 2019
# Desc:         Sed Basics
# Usage:        ./sed.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export Blue='\e[0;34m'          # Blue
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

: ' The two functions below colorize
    comments in green, and
    commands in red.'

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi
reset

echo -e "${BGreen}# Hash Collisions make it possible for two different files to have the same hash.${NC}"
echo -e "${BRed}md5sum file_A file_B${NC}"
echo -e "b1946ac92492d2347c6235b4d2611184  file_A"
echo -e "b1946ac92492d2347c6235b4d2611184  file_B"
echo -e "${BGreen}# The chance that it has hash collisions in two different hash functions is virtually 0.${NC}"
echo -e "${BRed}sha1sum file_A file_B${NC}"
echo -e "f572d396fae9206628714fb2ce00f72e94f2258f  file_A"
echo -e "1d229271928d3f9e2bb0375bd6ce5db6c6d348d9  file_B"

echo -e "\n${BGreen}#  The file command uses differnt signatures to determine what type of file it is.${NC}"
echo -e "${BGreen}#+ However these signatures can be modified to avoid detection.${NC}"
echo -e "${BRed}file my_Program${NC}"
echo -e "my_Program: ELF 64-bit LSB shared object, x86-64, version 1 (SYSV), dynamically linked, interpreter /lib64/l, for GNU/Linux 3.2.0, BuildID[sha1]=747e524bc20d33ce25ed4aea108e3025e5c3b78f, stripped"

echo -e "\n${BGreen}#  The strings command will return all plaintext strings from a binary file.${NC}"
echo -e "${BGreen}#+ Alot of them are usually things related to the language the program is written in,${NC}"
echo -e "${BGreen}#+ but you can always get lucky with some form of context clues.${NC}"
echo -e "${BRed}strings my_Program${NC}"
echo -e "/lib64/ld-linux-x86-64.so.2"
echo -e "libc.so.6"
echo -e "fflush"
echo -e "__printf_chk"
echo -e "setlocale"
echo -e "${BCyan}Enter"
echo -e "${BCyan}Username"
echo -e "${BCyan}Enter"
echo -e "${BCyan}Password${NC}"
echo -e "${BCyan}pass=ABC123${NC}"
echo -e ".dynamic"
echo -e ".data"
echo -e ".bss"
echo -e ".gnu_debuglink\n\n"
