
#---- Must Know PowerShell Commands to work with the Registry
    # Query
        get-childitem       # Use to display keys
        get-item            # Use to display key properties (values)

    # Modify
        set-itemproperty    # Modify an existing value
        remove-itemproperty # Remove an existing value

    #Create
        new-item            # Create a new sub-key
        new-itemproperty    # Create a new value



#---- To Navigate Registry Keys like a Filesystem

    # Will show all Keys and Values
        Get-ChildItem HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\
    # Will show Value
        Get-Item HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Run
    # Will show Properties of a Value
        Get-ItemProperty HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Run



    # Only Shows HKCU and HKLM by default
        Get-PSDrive         
    # Still can navigate to other Registry Keys
        Set-Location Registry::HKU
        Set-Location HKLM:\
    # To list subkeys without viewing their values
        Get-ChildItem | Select-Object -Property Name
    # View "Hivelist" (Mapping of Registry to Files on disk)
        Get-ItemProperty HKLM:\SYSTEM\CurrentControlSet\Control\hivelist\
    # Show the similarity to the filesystem
        (Get-Item '.\SOFTWARE\Microsoft\Windows\CurrentVersion\run').GetType()
        (Get-ChildItem '.\SOFTWARE\Microsoft\Windows\').GetType()



#---- Turn on/off "Hide File Extension"

    Set-ItemProperty -Path HKCU:\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced -Name "HideFileExt" -Value 0
    Set-ItemProperty -Path HKCU:\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced -Name "HideFileExt" -Value 1



#---- Sticky Keys CMD.exe Demo

    Get-ChildItem "hklm:\software\microsoft\windows nt\currentversion\image File Execution Options\"
    new-item "hklm:\software\microsoft\windows nt\currentversion\image File Execution Options\sethc.exe"
    New-ItemProperty -path "hklm:\software\microsoft\windows nt\currentversion\image File Execution Options\sethc.exe" -Name Debugger -Type String -Value C:\Windows\System32\cmd.exe
    Remove-ItemProperty -Path "hklm:\software\microsoft\windows nt\currentversion\image File Execution Options\sethc.exe" -Name Debugger
    Remove-Item "hklm:\software\microsoft\windows nt\currentversion\image File Execution Options\sethc.exe"


