#!/bin/bash

clean () {
# Checks if user want to clean up the aduditing environment
    read -p "Clean Rules? (y/n) " answer
    if test $answer == "y" || test $answer = "Y" ; then
        # Cleans up auditing environment
            cat /dev/null > /var/log/audit/audit.log
            cat /dev/null > /etc/audit/audit.rules
            cat /dev/null > /etc/test.conf
            if test -e /etc/file1 ; then rm /etc/file1 ; fi
            if test -e /test/test.conf ; then rm /test/test.conf ; fi
            auditctl -D &>/dev/null
    fi

}

setRules () {
  case $1 in
    1 ) auditctl -w /etc/ -k etc_watch
        ;;
    2 ) auditctl -w /etc/test.conf -k test_watch
        ;;
    3 ) auditctl -a exit,always -F arch=b64 -S open -F dir=/test -F success=1 -k test_open
        ;;
    4 ) auditctl -a exit,always -F arch=b64 -S write -F dir=/test -F success=1 -k test_write
        ;;
    5 ) auditctl -a exit,always -F arch=b64 -S open -S write -F dir=/test -F success=1 -k test_OW
        ;;
    6 ) auditctl -w /test/ -k testDir_watch
        ;;
    7 ) auditctl -w /test/test.conf -k testFile_watch
        ;;
  esac

}

getRulesMenu () {
    clear

    while :
    do
        clear

        echo "SET RULE MENU"
        echo "Choose from the following options:"
        echo "----------------------------------"
        echo "  [1] Set a rule to watch all files in /etc/"
        echo "  [2] Set a rule to watch the file /etc/test.conf"
        echo "  [3] Set a rule to audit all read calls in /test/"
        echo "  [4] Set a rule to audit all write calls in /test/"
        echo "  [5] Set a rule to audit all read/write calls in /test/"
        echo "  [6] Set a rule to watch all files in /test/"
        echo "  [7] Set a rule to watch the file /test/test.conf"
        echo
        echo "  [R] to Return to the main menu : [C] to Clear the Screen"


        read -p "Choice: " rules
        echo

        case "$rules" in
            1       ) setRules 1                             ;;
            2       ) setRules 2                             ;;
            3       ) setRules 3                             ;;
            4       ) setRules 4                             ;;
            5       ) setRules 5                             ;;
            6       ) setRules 6                             ;;
            7       ) setRules 7                             ;;

            [rR]    ) mainMenu                               ;;
            [cC]    ) clear                                  ;;
            *       ) echo "Please enter a valid option"     ;;
        esac
    done
}

setEdits () {
  case $1 in
    1 ) echo "Hello" >> /etc/test.conf
      ;;
    2 ) head /etc/passwd > /etc/file1
      ;;
    3 ) echo "Hello" >> /test/test.conf
      ;;
    4 ) head /etc/passwd > /test/test.conf
      ;;
    5 ) ls -l /test &>/dev/null
      ;;
  esac

}

getEditsMenu () {
    clear

    while :
    do
        clear

        echo "MAKE EDITS MENU"
        echo "Choose from the following options:"
        echo "----------------------------------"
        echo "  [1] echo \"Hello\" >> /etc/test.conf "
        echo "  [2] head /etc/passwd > /etc/file1 "
        echo "  [3] echo \"Hello\" >> /test/test.conf "
        echo "  [4] head /etc/passwd > /test/test.conf "
        echo "  [5] ls -l /test/ >/dev/null "
        echo
        echo "  [R] to Return to the main menu : [C] to Clear the Screen"

        read -p "Choice: " edit
        echo

        case "$edit" in
            1       ) setEdits 1                            ;;
            2       ) setEdits 2                            ;;
            3       ) setEdits 3                            ;;
            4       ) setEdits 4                            ;;
            5       ) setEdits 5                            ;;
            [rR]    ) mainMenu                              ;;
            [cC]    ) clear                                 ;;
            *       ) echo "Please enter a valid option"    ;;
        esac
    done
}

setResults () {
  case $1 in
      1 ) auditctl -l | less
        ;;
      2 ) ausearch -k etc_watch | aureport -f -i | less
        ;;
      3 ) ausearch -k test_watch | aureport -f -i | less
        ;;
      4 ) ausearch -k test_open | aureport -f -i | less
        ;;
      5 ) ausearch -k test_write | aureport -f -i | less
        ;;
      6 ) ausearch -k test_OW| aureport -f -i | less
        ;;
      7 ) ausearch -k testDir_watch| aureport -f -i | less
        ;;
      8 ) ausearch -k testFile_watch| aureport -f -i | less
        ;;
  esac

}

getResultsMenu () {
  clear

  while :
  do
      clear

      echo " SHOW RESULTS MENU"
      echo "Choose from the following options:"
      echo "----------------------------------"
      echo "  [1] Display all active rules"
      echo "  [2] View report on key: etc_watch "
      echo "  [3] View report on key: test_watch "
      echo "  [4] View report on key: test_open "
      echo "  [5] View report on key: test_write"
      echo "  [6] View report on key: test_OW"
      echo "  [7] View report on key: testDir_watch "
      echo "  [8] View report on key: testFile_watch "
      echo
      echo "  [R] to Return to the main menu : [C] to Clear the Screen"

      read -p "Choice: " results
      echo

      case "$results" in
          1     ) setResults 1                         ;;
          2     ) setResults 2                         ;;
          3     ) setResults 3                         ;;
          4     ) setResults 4                         ;;
          5     ) setResults 5                         ;;
          6     ) setResults 6                         ;;
          7     ) setResults 7                         ;;
          8     ) setResults 8                         ;;

          [rR]  ) mainMenu                              ;;
          [cC]  ) clear                                 ;;
          *     ) echo "Please enter a valid option"    ;;
      esac
  done

}

# Make menu of options for the user
mainMenu () {

clear

while :
do
    clear

    echo
    echo "Choose from the following options:"
    echo "----------------------------------"
    echo "  [0] Wipe all the previously existing rules and logs"
    echo "  [1] Display active rules"
    echo "  [2] Go to SHOW RESULTS display menu"
    echo "  [3] Go to MAKE EDIT menu"
    echo "  [4] Go to SET RULE menu"
    echo
    echo "  [X] to Exit : [C] to Clear the Screen" && echo

    read -p "Choice: " choice1
    echo

    case "$choice1" in
        0       ) clean                                 ;;
        1       ) setResults 1                          ;;
        2       ) getResultsMenu                        ;;
        3       ) getEditsMenu                           ;;
        4       ) getRulesMenu                          ;;
        [xX]    ) exit 0                                ;;
        [cC]    ) clear                                 ;;
        *       ) echo "Please enter a valid option"    ;;
    esac
done
}
# Run the program
mainMenu
