#!/bin/bash

./clear.run.sh

# Setup syscall rule and demo
echo -e ${LGREEN}"\n# Create a System Call rule" ${NC}
echo -e ${LRED} "\nauditctl -a exit,always -F arch=b64 -F euid=0 -S open -F path=$PWD/TEST -k rootcmd" ${NC}
auditctl -a exit,always -F arch=b64 -F euid=0 -S open -F path=$PWD/TEST -k rootcmd

echo -e ${LGREEN}"\n# Create a System Call rule" ${NC}
echo -e ${LRED} "\nauditctl -a exit,always -F arch=b64 -F -S open -F dir=/etc -F success=0 -k access" ${NC}
auditctl -a exit,always -F arch=b64 -S open -F dir=/etc -F success=0 -k access

# Make directory if necessary
if [ ! -d $PWD/TEST ]
then
	echo -e ${LRED} "\nmkdir $PWD/TEST && chmod 777 $PWD/TEST"
	mkdir $PWD/TEST && chmod 777 $PWD/TEST
fi

echo -e ${LGREEN}"\n\n############################\n\n" ${NC}

# Print rules
echo -e ${LRED} "\nauditctl -l" ${NC} ${LGREEN} "<-- Show the rules" ${NC}
auditctl -l

# Have root open files in $PWD/TEST

echo -e ${LRED} "\n"'grep root /etc/passwd > '"$PWD/TEST/test.txt" ${NC}
grep root /etc/passwd > $PWD/TEST/test.txt

echo -e ${LRED} "\nls $PWD/TEST/" ${NC}
ls $PWD/TEST/

# Have crotty open shadow file

echo -e ${LRED} "\nsudo - u crotty cat /etc/shadow" ${NC}
sudo -u crotty cat /etc/shadow

echo -e ${LGREEN}"\n\n############################\n\n" ${NC}

# View results

echo -e ${LRED} "\nausearch -k rootcmd" ${NC}
ausearch -k rootcmd && sleep .2

echo -e ${LRED} "\nausearch -k rootcmd | aureport -f -i" ${NC}
ausearch -k rootcmd | aureport -f -i  && sleep .2

echo -e ${LRED} "\nausearch -k access " ${NC}
ausearch -k access && sleep .2

echo -e ${LRED} "\nausearch -k access | aureport -f -i" ${NC}
ausearch -k access | aureport -f -i  && sleep .2

